###############################################################################
# AdminSubList.pm                                                             #
# $Date: 12.02.14 $                                                           #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 2.6.11                                                 #
# Packaged:       December 2, 2014                                            #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2014 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by:  The YaBB Development Team                                     #
#               with assistance from the YaBB community.                      #
###############################################################################

our $VERSION = '2.6.11';
$adminsublistpmver = 'YaBB 2.6.11 $Revision: 1615 $';

%director = (
'addboard' => 'ManageBoards.pm&AddBoards',
'addboard2' => 'ManageBoards.pm&AddBoards2',
'addcat' => 'ManageCats.pm&AddCats',
'addcat2' => 'ManageCats.pm&AddCats2',
'addmember' => 'Admin.pm&AddMember',
'addmember2' => 'Admin.pm&AddMember2',
'addsmilies' => 'Smilies.pm&AddSmilies',
'admincheck' => 'Admin.pm&AdminCheck',
'admincheck2' => 'Admin.pm&AdminCheck2',
'admin_descision' => 'RegistrationLog.pm&process_registration_review',
'apr_regentry' => 'RegistrationLog.pm&approve_registration',
'assigned' => 'MemberGroups.pm&Assigned_Members',
'assigned2' => 'MemberGroups.pm&Assigned_Members2',
'ban_clean' => 'Ban.pm&ban_clean',
'banlog' => 'Ban.pm&banlog',
'backupsettings' => 'Backup.pm&backupsettings',
'backupsettings2' => 'Backup.pm&backupsettings2',
'boardrecount' => 'Maintenance.pm&AdminBoardRecount',
'boardscreen' => 'ManageBoards.pm&BoardScreen',
'bookmarks' => 'Settings_Bookmarks.pm&Bookmarks',
'bookmarks2' => 'Settings_Bookmarks.pm&Bookmarks2',
'bookmarks_add' => 'Settings_Bookmarks.pm&AddBookmark',
'bookmarks_delete' => 'Settings_Bookmarks.pm&DeleteBookmark',
'bookmarks_edit' => 'Settings_Bookmarks.pm&EditBookmark',
'bookmarks_edit2' => 'Settings_Bookmarks.pm&EditBookmark2',
'catscreen' => 'ManageCats.pm&DoCats',
'checkspace' => 'Checkspace.pm&checkspace',
'checkspace_save' => 'Checkspace.pm&checkspace_save',
'clean_log' => 'Maintenance.pm&clean_log',
'clean_reglog' => 'RegistrationLog.pm&clean_reglog',
'cleanerrorlog' => 'ErrorLog.pm&CleanErrorLog',
'convdelete' => 'Admin.pm&DeleteConverterFiles',
'createcat' => 'ManageCats.pm&CreateCat',
'del_regentry' => 'RegistrationLog.pm&kill_registration',
'deleteattachment' => 'Attachments.pm&DeleteAttachments',
'deletepmattachment' => 'Attachments.pm&DeletePMAttachments',
'deletebackup' => 'Backup.pm&deletebackup',
'deletebackup2' => 'Backup.pm&deletebackup2',
'deleteerror' => 'ErrorLog.pm&DeleteError',
'deletemail' => 'Admin.pm&MailList',
'deletemultimembers' => 'Admin.pm&DeleteMultiMembers',
'deleteoldthreads' => 'Admin.pm&DeleteOldMessages',
'delgroup' => 'MemberGroups.pm&deleteGroup',
'detailedversion' => 'Admin.pm&ver_detail',
'downloadbackup' => 'Backup.pm&downloadbackup',
'editAddGroup2' => 'MemberGroups.pm&editAddGroup2',
'editbots' => 'AdminEdit.pm&EditBots',
'editbots2' => 'AdminEdit.pm&EditBots2',
'editemailtemplates' => 'EditEmailTemplates.pm&editemailtemplates',
'editemailtemplates2' => 'EditEmailTemplates.pm&editemailtemplates2',
'editgroup' => 'MemberGroups.pm&editAddGroup',
'editgroup1' => 'MemberGroups.pm&editAddGroup',
'editpaths' => 'AdminEdit.pm&EditPaths',
'editpaths2' => 'AdminEdit.pm&EditPaths2',
'eventcal_set' => 'EventCalSet.pm&EventCalSet',
'eventcal_set2' => 'EventCalSet.pm&EventCalSet2',
'eventcal_set3' => 'EventCalSet.pm&EventCalSet3',
'emailbackup' => 'Backup.pm&emailbackup',
'errorlog' => 'ErrorLog.pm&ErrorLog',
'ext_admin' => 'Settings_ExtendedProfiles.pm&ext_admin',
'ext_convert' => 'Settings_ExtendedProfiles.pm&ext_admin_convert',
'ext_create' => 'Settings_ExtendedProfiles.pm&ext_admin_create',
'ext_edit' => 'Settings_ExtendedProfiles.pm&ext_admin_edit',
'ext_edit2' => 'Settings_ExtendedProfiles.pm&ext_admin_edit2',
'ext_reorder' => 'Settings_ExtendedProfiles.pm&ext_admin_reorder',
'gmodaccess' => 'AdminEdit.pm&GmodSettings',
'gmodsettings2' => 'AdminEdit.pm&GmodSettings2',
'guardian_block' => 'GuardianAdmin.pm&guardian_block',
'helpadmin' => 'EditHelpCentre.pm&MainAdmin',
'helpediting' => 'EditHelpCentre.pm&HelpEdit',
'helpediting2' => 'EditHelpCentre.pm&HelpEdit2',
'helporder' => 'EditHelpCentre.pm&SetOrderFile',
'helpsettings2' => 'EditHelpCentre.pm&HelpSet2',
'honeypot' => 'HoneyPot.pm&honeypot',
'honeypot_add' => 'HoneyPot.pm&honeypot_add',
'honeypot_edit' => 'HoneyPot.pm&honeypot_edit',
'honeypot_edit2' => 'HoneyPot.pm&honeypot_edit2',
'honeypot_delete' => 'HoneyPot.pm&honeypot_delete',
'ipban' => 'Ban.pm&ipban',
'ipban_add' => 'Ban.pm&ipban_add',
'ipban_err' => 'Ban.pm&ipban_err',
'ipban2' => 'Ban.pm&ipban2',
'mailing' => 'MailMembers.pm&Mailing',
'mailing2' => 'MailMembers.pm&Mailing2',
'mailing3' => 'MailMembers.pm&Mailing3',
'mailinggrps' => 'MailMembers.pm&MailingMembers',
'mailmultimembers' => 'Admin.pm&DeleteMultiMembers',
'manageattachments' => 'Attachments.pm&Attachments',
'manageattachments2' => 'Attachments.pm&Attachments2',
'manageboards' => 'ManageBoards.pm&ManageBoards',
'managecats' => 'ManageBoards.pm&ManageBoards',
'managepmattachments2' => 'Attachments.pm&PMAttachments2',
'membershiprecount' => 'Maintenance.pm&AdminMembershipRecount',
'ml' => 'ViewMembers.pm&Ml',
'modagreement' => 'AdminEdit.pm&ModifyAgreement',
'modagreement2' => 'AdminEdit.pm&ModifyAgreement2',
'modcss' => 'ManageTemplates.pm&ModifyCSS',
'modcss2' => 'ManageTemplates.pm&ModifyCSS2',
'modifyboard' => 'ManageBoards.pm&ModifyBoard',
'modifycat' => 'ManageCats.pm&ModifyCat',
'modifycatorder' => 'ManageCats.pm&ReorderCats',
'modlist' => 'ModList.pm&ListMods',
'modmemgr' => 'MemberGroups.pm&EditMemberGroups',
'modmemgr2' => 'MemberGroups.pm&EditMemberGroups2',
'modskin' => 'ManageTemplates.pm&ModifySkin',
'modskin2' => 'ManageTemplates.pm&ModifySkin2',
'modstyle' => 'ManageTemplates.pm&ModifyStyle',
'modstyle2' => 'ManageTemplates.pm&ModifyStyle2',
'modtemp' => 'ManageTemplates.pm&ModifyTemplate',
'modtemp2' => 'ManageTemplates.pm&ModifyTemplate2',
'newsettings' => 'NewSettings.pm&settings',
'newsettings2' => 'NewSettings.pm&settings2',
'rebuildattach' => 'Attachments.pm&FullRebuildAttachents',
'rebuildmemhist' => 'Maintenance.pm&RebuildMemHistory',
'rebuildmemlist' => 'Maintenance.pm&RebuildMemList',
'rebuildmesindex' => 'Maintenance.pm&RebuildMessageIndex',
'rebuildnotifications' => 'Maintenance.pm&RebuildNotifications',
'rebuildpmattach' => 'Attachments.pm&FullRebuildPMAttachments',
'recoverbackup1' => 'Backup.pm&recoverbackup1',
'recoverbackup2' => 'Backup.pm&recoverbackup2',
'referer_control' => 'Admin.pm&Refcontrol',
'referer_control2' => 'Admin.pm&Refcontrol2',
'rej_regentry' => 'RegistrationLog.pm&reject_registration',
'remghostattach' => 'Attachments.pm&RemoveGhostAttach',
'remghostpmattach' => 'Attachments.pm&RemoveGhostPMAttach',
'removebigattachments' => 'Attachments.pm&RemoveBigAttachments',
'removebigpmattachments' => 'Attachments.pm&RemoveBigPMAttachments',
'removeoldattachments' => 'Attachments.pm&RemoveOldAttachments',
'removeoldpmattachments' => 'Attachments.pm&RemoveOldPMAttachments',
'removeoldthreads' => 'RemoveOldTopics.pm&RemoveOldThreads',
'reorderboards' => 'ManageBoards.pm&ReorderBoards',
'reorderboards2' => 'ManageBoards.pm&ReorderBoards2',
'reordercats' => 'ManageCats.pm&ReorderCats',
'reordercats2' => 'ManageCats.pm&ReorderCats2',
'reordergroup' => 'MemberGroups.pm&reorderGroups',
'reordergroup2' => 'MemberGroups.pm&reorderGroups2',
'runbackup' => 'Backup.pm&runbackup',
'setcensor' => 'AdminEdit.pm&SetCensor',
'setcensor2' => 'AdminEdit.pm&SetCensor2',
'setreserve' => 'AdminEdit.pm&SetReserve',
'setreserve2' => 'AdminEdit.pm&SetReserve2',
'setup_guardian' => 'GuardianAdmin.pm&setup_guardian',
'setup_guardian2' => 'GuardianAdmin.pm&setup_guardian2',
'showclicks' => 'Admin.pm&ShowClickLog',
'smilieindex' => 'Smilies.pm&SmilieIndex',
'smiliemove' => 'Smilies.pm&SmilieMove',
'smilieput' => 'Smilies.pm&SmiliePut',
'smilies' => 'Smilies.pm&SmiliePanel',
'spam_questions' => 'AntispamQuestions.pm&SpamQuestions',
'spam_questions2' => 'AntispamQuestions.pm&SpamQuestions2',
'spam_questions_add' => 'AntispamQuestions.pm&SpamQuestionsAdd',
'spam_questions_delete' => 'AntispamQuestions.pm&SpamQuestionsDelete',
'spam_questions_edit' => 'AntispamQuestions.pm&SpamQuestionsEdit',
'spam_questions_edit2' => 'AntispamQuestions.pm&SpamQuestionsEdit2',
'stats' => 'Admin.pm&FullStats',
'view_regentry' => 'RegistrationLog.pm&view_registration',
'view_reglog' => 'RegistrationLog.pm&view_reglog',
'viewmembers' => 'ViewMembers.pm&Ml',
'blockip' => 'ErrorLog.pm&blockip',
);

1;
